*****************************************************
*                  RING pour HP28S                  *
*            321,5 octets  cksum # 5D77h            *
*                                                   *
*    auteur Guy Toublanc           le 28/06/1994    *
*                                                   *
* 1re syntaxe :                                    *
*      niveau 2 : R rayon du cercle                 *
*      niveau 1 : ( Xc , Yc ) centre du cercle      *
*                                                   *
* 2me syntaxe :                                    *
*      niveau 2 : ( R , r ) rayons de l'anneau      *
*      niveau 1 : ( Xc , Yc ) centre du cercle      *
*                                                   *
* si R > r trac de l'extrieur vers le centre      *
* si R < r trac du centre vers l'extrieur         *
*                                                   *
* Xc, Yc : rels quelconques                        *
* R , r  : rels positifs                           *
*                                                   *
*  sytme de coordonnes absolues :                 *
*                                                   *
*        0  -------------------------> 136          *
*           |                                       *
*           |                                       *
*           |                                       *
*        31 V                                       *
*                                                   *
*   9 CF : cercle ou anneau trac                   *
*   9 SF : cercle ou anneau effac                  *
*                                                   *
* fichier source compilable sur PC par RPLCOMP de HP*
*****************************************************

CODE
         gosbvl  =SAVPTR
         c=0     w          * pour initaialiser
         c=c-1   a          * c(a) := FFFFFh
         c=0     b          * c(a) := FFF00h
         d0=c               * @ speed
         dat0=c  xs         * pour speed maxi
         clrst              * intilialise st ....
         d0=(5)  #c0111     * @ flag 9
         a=dat0  1          * flags 12  9
         ?abit=0 0          * 9 FC?
         goyes   circleon   * oui alors on allumera
         st=1    3          * pour cercle  effacer
circleon
         c=dat1  a          * adresse complexe niv.1
         gosub   pop&conv   * Xc : conversion en hexa
         r3=c               * sauve Xc -> R3
         gosub   popim      * conversion Yc en hexa
         r0=c               * sauve Yc -> R0
         d0=d0+  5          * @ 2ime niveau
         c=dat0  a          * adresse R
         gosub   pop&conv   * R : conversion
         r2=c               * sauve Y = R -> R2
         ?st=0   0          * R seul ?
         goyes   Ronly
         gosub   popim      * conversion r
Ronly
         a=r2               * R    
         c=a-c   a          * R - r
         gonc    R>r
         st=1    1          * pour R < r
         c=-c    a          * valeur absolue
R>r      

*****************************************************
*                                                   *
*       Boucle de trac des cercles successifs      *
*                                                   *
*  en entre :                                      *
*           C(A) := nombre de cercle  tracer       *
*           A(A) := R2(A) := R courant              *
*           R0   := Yc                              *
*           R3   := Xc                              *
*           ST1 = 0  : R > r                        *
*           ST0 = 1  : R < r                        *
*           ST3 = 0  : pixels allums               *
*           ST3 = 1  : pixels teints               *
*****************************************************

gloop
         rstk=c             * sauve |R-r| et index
         r4=a               * sauve R  A(A) := Y = R
         a=a+a   a
         c=0     a
         r1=c               * dpart X=0 sauve X
         lchex   3
         c=c-a   a          * d = 3 - 2*r
         d=c     a          * sauve d
         c=r1               * C(A):=X
         goto    start      * dpart trac

*****************************************************
*                                                   *
*          Boucle de trac d'un cercle              *
*            algorithme de Bresenham                *
*     avec un point calcul (X,Y), les symtries    *
*     permettent de tracer huit points              * 
*                                                   *
*****************************************************

loop     gosub   plot       * trac de 8 points
         p=      4
         c=r1               * X
         ?d#0    p
         goyes   dnegat
         cr2ex              * Y
         c=c-1   a          * Y - 1
         b=c     a          * sauve Y
         cr2ex              * sauve Y     C:=X
         c=c-b   a          * X := X - Y
dnegat   c=c+c   a              
         c=c+c   a          * 4X
         p=      0
         d=d+c   a
         d=d+con a,6        * d =: d + 4X + 6
         c=r1               * X
         c=c+1   a          * X := X + 1
         r1=c               * sauve X
start    a=r2               * Y
         c=c-a   a          * X - Y 
         goc     loop       * X < Y ? alors loop
         c=r1               * X
         ?c#a    a          * X <> Y ?
         goyes   next       * alors sortie
         gosub   plot       * encore trac
next     c=rstk             * paisseur anneau
         c=c-1   a          * restante
         goc     out        * nulle alors sortie
         a=r4               * R
         a=a-1   a          * pour le cercle suivant
         ?st=0   1          * R > r
         goyes   R>>r       * oui alors c'est bon
         a=a+con a,2        * sinon incrmentation
R>>r
         r2=a               * sauve Y := R
         goto    gloop
out      govlng  =GETPTRLOOP

negyy    c=r1               * ces divers segments
         c=-c    a          * de programme
         r1=c               * effectuent les
         goto    negy       * permutations entre X
xyexx    c=r1               * et Y et changements
         c=-c    a          * de signe pour obtenir
         r1=c               * par symtrie 8 points
         goto    xyex

plot     st=0    0          * marque 1er tour
loop2    gosub   plotxy     * 
         goc     negyy
         gosub   lxx
negy     c=r2               * Y
         c=-c    a          * Y := Y
         r2=c               * sauve Y
         gosub   plotxy2    * 
         goc     xyexx
         gosub   lxx
xyex     c=r1               * X
         cr2ex              * Y := X
         c=-c    a          * X := -Y
         r1=c               * sauve X
         ?st=1   0          * 2e tour ?
         rtnyes             * alors retour
         st=1    0          * marque 2e tour
         gonc    loop2
lxx      c=r1               * encore symtrie
         c=-c    a
         r1=c
plotxy
         c=r2               * Y
plotxy2  a=r0               * Yc
         a=a-c   a          * Yi
         lc(5)   31
         ?c<a    a          * Yi > 31 ?
         rtnyes             * oui on ne fait rien
         d1=a               * sauve Yi
         a=r1               * X
         c=r3               * Xc
         a=a+c   a          * Xi
         lc(5)   137        * ex 136
         ?a<c    a          * Xi < 137 ?
         goyes   Xok
         rtncc
Xok      lc(2)   67
         ?c>=a   b          * Xi <= 67 ?
         goyes   left       * oui demi cran gauche
         a=a-c   a          * Xi pour 1/2 cr. droit
left
         lchex   ffbf8      * adresse 1/2 cr. droit
         gonc    right      * si Xi > 67 saut cr-dr
         lchex   840        * FF840 pour 1/2 cr-g
right
         a=a+a   a
         a=a+a   a
         a=a+a   a          * colonne pour Xi
         a=a+c   a          * adresse colonne
         ad1ex              * @ colonne  a(A) =: Yi
         d0=a               * sauve Yi
         asrb
         asrb               * Yi en quartets
         cd1ex              * adresse colonne
         c=c+a   a          * adresse quartet pour Yi
         cd1ex              * @ quartet Yi
         ad0ex              * Yi
         lchex   3
         a=a&c   p          * Yi modulo 4
         lchex   1          * rcupre 1 de 1F (31d)
         gonc    decr       * dpart pour position

loop4    c=c+c   p          * position pixel dans nib
decr     a=a-1   p          * compteur
         gonc    loop4

         a=dat1  b          * quartet du pixel en mem
         ?st=0   3          * PIXON ?
         goyes   pixon
         a=-a-1  p          * inversion pour PIXOFF     
pixon
         a=a!c   p          * OR pour PIXON ou PIXOFF
         goc     pixon2     * saut pour PIXON
         a=-a-1  p          * inversion pour PIXOFF
pixon2
         dat1=a  1          * quartet modifi
         rtncc

pop&conv cd1ex              * @ prologue
         d0=c               * sauve D1
         a=dat1  a
         a=a+a   a
         a=a+a   b
         st=0    0          * pour rel
         gonc    real
         st=1    0          * pour complexe
real
         d1=d1+  4

popim    d1=d1+  1          * @ exposant
         a=0     a
         a=dat1  x          * exposant
         lchex   500
         ?c>a    x          * exposant positif ?
         goyes   exppos
         b=0     a          * 0,.... arrondi  0
         d1=d1+  15         * pour partie imag.
         gonc    convrtn
exppos
         lchex   003        * si exposant > 3
         ?c>=a   x          * alors exposant = 3
         goyes   exp<4
         a=c     x
exp<4
         d1=d1+  14         * @ digit de poids fort
         ad1ex              * a(A) =: D1
         cd1ex              * C(A) =: exposant
         p=c     0          * P =: exposant
         c=a-c   a          * adresse digit de poids
         d1=c               * faible (mantisse)
         a=0     a
         a=dat1  wp         * mantisse
         b=a     a          * sauvegarde
         d=0     a          * initialisation
         c+p+1              * adresse aprs mantisse
         d1=c               * @ le signe
         p=      0
         c=0     a
         lchex   6          * 3e cste de conversion
         rstk=c             * sauvegarde
         lchex   9c         * 2e cste de conversion
         rstk=c             * sauvegarde
         lchex   c18        * 1e cste de conversion
         p=      3          * compteur pour loop5

loop5    a=b     p          * et pointeur de digits
         gonc    decr3      * dpart conversion

loop3    d=d+c   a
decr3    a=a-1   p
         gonc    loop3

         p=p-1              * position suivante
         ?p=     0          * plus de digits ?
         goyes   cont       * alors sortie de loop5
         c=rstk             * dpile constante suiv.
         gonc    loop5      * tour suivant de boucle

cont     c=d     a
         b=b-c   a          * rsultat en hexa
         a=dat1  1          * signe
         ?a=0    p          * positif ?
         goyes   pos
         b=-b    a          * si non entier sign
pos
convrtn  c=b     a          * nombre converti
         rtn
ENDCODE
