; Partie en RPL conventionnel

\<< DUP 14 \<= IF THEN FACT \->STR ELSE DUP 2 * \pi * LOG 2 / OVER DUP LOG *
    + OVER e LOG * - OVER 12 * INV 1 + LOG + CEIL R\->B SWAP R\->B

    BEGINCODE

; Partie en assembleur

; Convention d'criture :
; =======================

;    grp[k] = (k+1) groupe de 5 chiffres
;    R0.A = champ A du registre R0

; Utilisation des registres :
; ===========================

; A : registre de calcul
; B :
; C : registre de calcul
; D : N du groupe de 5 chiffres courant

; D0 : ^grp[k]
; D1 :

; R0 : champ A : nombre total de groupes
;      reste : nombre de chiffres de n!
; R1 ; champ A : adresse de n!
;      reste :
; R2 : n, n-1, n-2, ... , 1, 0
; R3 : retenue temporaire
; R4 : non utilis

; On commence par initialiser les
; divers registres et rserver
; la mmoire ncessaire

        include addr-48.as

        nibhex  begin_code
        rel(5)  fin_code
        gosbvl  save_reg
        gosbvl  garb_collect
        gosbvl  load_reg
        a=dat1  a
        d0=a
        d0=d0+10
        a=0     w
        a=dat0  a
        r2=a      ; R2 = n
        d1=d1+5
        a=dat1  a
        d0=a
        d0=d0+10
        a=dat0  a ; A = # de chiffres
        c=a     a ;     de n!
        csl     w
        csl     w
        csl     w
        csl     w
        csl     w
        r0=c
        c=0     w
        lchex   #00005
        c=c+a   a
        c=c+c   a
        gosbvl  malloc
        gonc    ok ; si assez de mmoire
        gosbvl  load_reg
        a=dat0  a
        d0=d0+5
        pc=(a)
ok      ad0ex   ; A = ^n!
        r1=a
        gosbvl  load_reg
        a=r1
        dat1=a  a
        d1=a
        lchex   prolog_string
        dat1=c  a
        d1=d1+5
        lchex   #00005
        a=c     a
        c=r0
        csr     w
        csr     w
        csr     w
        csr     w
        csr     w
        c=c+c   a
        c=c+a   a
        dat1=c  a
        c=c-a   a
        d1=d1+5
        gosbvl  write_zeroes
        c=r1
        d1=c
        d1=d1+10
        lchex   #1
        dat1=c  1 ; grp[0] := 1

; On calcule n! comme suit :

; 0. R0.A := 0; grp[0] := 1;
; 1. retenue := 0;
; 2. pour k := 0, k <= R0.A faire
;         c := grp[k] * n
;         c := c + retenue
;         grp[k] := c mod 100000
;         retenue := c div 100000
;    fin_pour
; 3. si retenue # 0 alors
;         R0.A := R0.A + 1;
;         grp[R0.A] := retenue
;    fin_si
; 4. n := n - 1;
; 5. si n # 0 alors aller  1.
;             sinon stop
;    fin_si

loop    c=0     w ; boucle principale
        r3=c      ; ajuste la retenue
        c=r1
        d0=c
        d0=d0+10  ; D0 = ^grp[k=0]
        c=r0      ; Nombre total de
        d=c     a ; groupes utiliss
l1      a=0     w
        a=dat0  a
        c=r2
        setdec ; petite astuce ...
        gosbvl  multiply
        a=r3
        c=c+a   w ; ajoute la retenue
        sethex    ; retour en hexa
        dat0=c  a ; grp[k] = C.A
        csr     w
        csr     w
        csr     w
        csr     w
        csr     w
        r3=c       ; nouvelle retenue
        d0=d0+5    ; k := k+1
        d=d-1   a  ; encore un groupe ?
        gonc    l1 ; oui
        a=r3       ; dernire retenue
        ?a=0    a  ; retenue nulle ?
        goyes   l2 ; oui ==> l2
        dat0=a  a  ; grp[k] := retenue
        a=r0       ; on incrmente le
        a=a+1   a  ; nombre total de
        r0=a       ; groupes utiliss
l2      c=r2       
        c=c-1   a
        r2=c       ; on dcrmente R2
        ?c!=0   a  ; R2 # 0 ?
        goyes   loop ; oui

; Maintenant, il faut transformer notre
; nombre en une chane de caractres.
; On commence par recopier le nombre
;  la fin de l'espace mmoire rserv.

        c=r0
        csr     w
        csr     w
        csr     w
        csr     w
        csr     w
        b=c     a
        d=c     a
        a=r1
        d0=a
        d0=d0+10
        a=a+c   a
        d1=a
        d1=d1+10
        gosbvl  copy_nibs

; Puis on transforme chaque chiffre
; en code hexadcimal correspondant

        a=r1
        d0=a
        d0=d0+10
        a=a+b   a
        d1=a
        d1=d1+10
        d=d-1   a
l3      lchex   #30
        c=dat1  1
        dat0=c  b
        d0=d0+2
        d1=d1+1
        d=d-1   a
        gonc    l3
        d0=d0-2
        d=0     w
        c=b     a
        d=c     a
        dsrb
        d=d-1   a
        a=r1
        d1=a
        d1=d1+10
l4      a=dat1  b
        c=dat0  b
        dat0=a  b
        dat1=c  b
        d1=d1+2
        d0=d0-2
        d=d-1   a
        gonc    l4
        gosbvl  load_reg
        a=dat0  a
        d0=d0+5
        pc=(a)
fin_code        ENDCODE

; Retour en mode RPL conventionnel

        SWAP DROP END \>>
