*****************************************************************************
*****************************************************************************
**                                  XPEEKU                                 **
**                     (cksum: # 9092h   287.5 octets)                     **
**                         Peek en Rom cache ou non                       **
**                       pour les HP48S(X) et HP48G(X)                     **
**          et quelle que soit la position du programme en Ram ou Rom      **
**                  sauf ports 2 et suivants de la HP48Gx                  **
**    Cration : 21/09/93                         Auteur : Guy Toublanc    **
**                               (programme inspir des programmes Rompeek **
**                                des livres "Voyage au centre de la HP48" **
**                                de P. Courbis et S. Lalande)             **
**    Dernire modification : 13/10/93                                     **
**    Syntaxe : niveau 2 <- 1 entier binaire pour l'adresse o "Peeker"    **
**              niveau 1 <- 1 entier binaire ou 1 reel pour le nombre      **
**                          de quartets  prendre en mmoire (Rom)         **
*****************************************************************************
*****************************************************************************

::
 0LASTOWDOB! CK2NOLASTWD
 DUPTYPEREAL? IT %>#
 CK&DISPATCH1 <BBh>
 ::
CODE

*****************************************************************************
* ci-dessous sont indiqus des mnmoniques pour des points d'entre dans    *
* les cas suivants:                                                         *
*    non support : point d'entre spcifique  un type de machine et       *
*                   interne  une routine dont le point d'entre n'est pas  *
*                   support. Mnmonique maison                             *
*    non support mais fixe : bien que non support adresse fixe pour les   *
*                             versions jusque P. Mnmonique maison          *
*    fixe : adresse de Ram interne qui pour des raisons physique reste fixe *
*           Mnmonique maison                                               *
*    fixe pour HP48S(X) ou HP48G(X) : adresses de la Ram rserve qui pour  *
*                                     un mme type de machine ne devraient  *
*                                     pas varier. Mnmonique maison         *
*****************************************************************************

=<BBh>           EQU  #64dce   * non support mais fixe
=uart_bufferS    EQU  #701fc   * fixe pour HP48S(X)
=uart_bufferG    EQU  #80319   * fixe pour HP48G(X)
=bank_switchrG   EQU  #7e000   * fixe pour HP48G(X)
=UnCover128K_G   EQU  #70b66   * non support
=Cover128K_G     EQU  #70bb7   * non support
=moveram_gsbG    EQU  #700fe   * non support
=moveram_gsbS    EQU  #026bf   * non support
=ramIO           EQU  #00100   * fixe

         gosub   trans
start    c=r1                     * nombre de quartets  peeker
         c=c+c   a                * nombre de quartes de la chane des codes
         gosbvl  =MAKE$N          * gnre la chane revevant les codes
         c=r1                     * nombre de quartets  peeker
         b=c     a                * compteur de codes
         c=r2                     * adresse du peek
         d1=c                     * @ dpart o peeker   
         goto    decr             * dpart sur actualisation du compteur

*****************************************************************************
* loop : boucle oprant suivant un partitionnement de la mmoire            *
*        HP48S(X) : # 0h - # FFh, # 100h - # 13Fh, # 140h - # 6FFFFh        *
*                   # 70000h - # 7FFFFh (limite de la Rom                   *
*        HP48S(X) : # 0h - # FFh, # 100h - # 13Fh, # 140h - # 7DFFFh        *
*                   # 7E000h - # 7EFFFh, # 7F000h - # 7FFFFh                *
*                   # 80000h - # BFFFFh, # C0000h - # FFFFFh                *
*        suivant la position en mmoire du quartet  peeker on fait:        *
*              un peek simple pour les plages de Rom non caches par la Ram *
*              une ou plusieurs dconfigurations avant de peeker le quartet *
*              puis une ou plusieurs reconfigurations                       *
*        Il est tenu compte du type de Rom HP48S(X) ou HP48G(X)             *
* entres : D0 @ la position du futur caractre de la chane du peek        *
*           D1 @ la position du futur quartet  peeker                      *
*           R2(A) adresse de la position du futur quartet  peeker          *
*           B(A) := compteur du nombre de quartets  peeker                 *
*           ST(0) = 0 pour HP48G(X) et = 1 pour HP48S(X)                    *
* sorties  : idem + 1 caractre (code -> ascii) ajout  la chane du peek  *
*****************************************************************************

loop     gosbvl  =DisableIntr     * inhibe les interruptions
         cd0ex
         r1=c                     * sauvegarde la position dans la chane
         ad1ex                    * adresse position du code
         d1=a
         ?st=0   0                * HP48G(X) ?
         goyes   rom48g        
         lchex   70000            * dpart RAM HP48S(X)
         ?a>=c   a                * peek dans Rom cache par Ram rserve ?
         goyes   pop48s

******************************
*  pour HP48S(X) et HP48G(X)
******************************

rom48g   lc(5)   (ramIO)+64
         ?a>=c   a                * peek dans Rom situe au-dessus Ram I/O ?
         goyes   noram0
         c=0     b
         ?a<c    a                * peek dans Rom situe au-dessous Ram I/O ?
         goyes   noram0
         a=0     a                * en ralit la Ram I/O ne recouvre rien
         gonc    load             * saut pour charger le quartet

******************************
* pour HP48G(X)
******************************

noram0   lc(5)   =bank_switchrG
         ?a>=c   a                * adresse du peek >= adresse bank-switcher?
         goyes   testram1
         a=dat1  1                * non alors Rom non cache : peek normal
         gonc    load             * saut pour charger le quartet peek

******************************
* pour HP48G(X)
******************************

testram1 lchex   80000
         ?a>=c   a                * adresse du peek >= adresse Ram rserve ?
         goyes   testram3
         lc(5)   (bank_switchrG)+4096
         ?a>=c   a                * adresse du peek au-dessus Ram rserve ?
         goyes   noram1
         lc(4)   =bank_switchrG   * pour dcouvrir ce module de Rom cache
         gosub   sub0             * accde  cette Rom cache et peek 1 nib
         gonc    load             * saut pour charger le quartet peek

******************************
* pour HP48G(X)
******************************

noram1   gosub   sub00            * accde  cette Rom cache et peek 1 nib
         rstk=c                   * sauve adresse config
         config                   * reconfigure le module
         c=rstk                   * restaure adresse config
         config                   * reconfiguration
         gonc    load             * saut pour charger le quartet peek

******************************
* pour HP48G(X)
******************************

testram3 lchex   c0000
         ?a>=c   a                * adresse du peek >= adresse IRam ?
         goyes   ram3

***********************************************************
* pour HP48S(X) et HP48G(X)
* ici l'adresse du peek est dans la plage de la Ram interne
***********************************************************

pop48g
pop48s   gosub   gram             * dplace la Ram et appelle pop puis saut
pop      c=r2                     * pour charger le quartet peek
         d1=c                     * @ code
         a=dat1  1                * code peek
         r4=a                     * sauvegarde du quartet peek
         rtn

******************************
* pour HP48G(X)
******************************

ram3     gosbvl  =UnCover128K_G   * dcouvre la Rom cache, ici C0000-FFFFF 
         a=dat1  1
         gosbvl  =Cover128K_G     * replace la Ram


*****************************************************************************
* ici se rejoignent tous les sauts correspondant aux diffrentes parties de *
* Rom peeke. Tout a t reconfigur comme  l'origine. Il ne reste plus    *
* qu' faire la conversion classique Hexa-> ASCII du code peek et le       *
* stocker dans la chane rsultat.
*****************************************************************************

load     gosbvl  =AllowIntr       * autorise les interruptions
         c=r1
         d0=c                     * @ le caractre suivant de la chane
         lchex   39               * conversion
         acex    p                * hexa -> ascii
         ?c<=a   p                * du code peek
         goyes   inf10            *
         c=c+con b,7              *
inf10    dat0=c  b                * charge la valeur ascii
         d0=d0+  2                * actualise D0 et D1
         d1=d1+  1                * pour le code suivant
decr     b=b-1   a                * actualise compteur de codes
         goc     out              * sortie si plus de codes
         goto    loop             * sinon encore tour de boucle
out      a=r0                     * adresse de la chane
         govlng  =GPOverWrALp     * GETPTR l'adresse de la chane remplace
*                                   l'adresse du peek puis retour au Rpl

*****************************************************************************
* gram : accs  la Rom cache dans la plage :                              *
*               # 70000h - # 7FFFFh pour HP48S(X)                           *
*               # 80000h - # 8FFFFh pour HP48G(X)                           *
*       D1 et le compteur sont sauvegards                                  *
*       la RAm est dplace puis le sous programme pop est excut pour     *
*       peeker 1 quartet sauvegard en R4(0)                                *
*       la Ram est replace                                                 *
*       D1, le compteur et le quartet peek sont restaurs                  *
*****************************************************************************

gram     cd1ex
         r2=c                     * sauve position du code
         c=b     a
         r3=c                     * sauve compteur de codes
         c=rstk
         ?st=0   0                * HP48G(X) ?
         goyes   contg

******************************
*  pour HP48S(X)
******************************

         p=      15               * # F....h + # .aaaah (adresse de pop)
         cpex    4                * -> # Faaaah nouvelle adresse de pop
         gosbvl  =moveram_gsbS    * dplace la Ram et appelle pop
         gonc    conts            * saut  fin de routine commune G et S

******************************
*  pour HP48G(X)
******************************

contg    p=      12               * # C....h + # .aaaah (adresse de pop)
         cpex    4                * -> # Caaaah nouvelle adresse de pop
         p=      0
         gosbvl  =moveram_gsbG    * dplace la Ram et appelle pop

******************************
*  pour HP48S(X) et HP48G(X)
******************************

conts    c=r3                     * pour restaure compteur de codes
         b=c     a
         c=r2                     * pour restaure D1 position o peeker
         d1=c                     * @ position o peeker
         a=r4                     * A(0) := quartet peek
         gonc    load             * saut pour charger la chane peeke

*****************************************************************************
* sub0 et sub00 sont utiliss pour des dconfiguration et reconfigurations  *
*          de Ram de 4K                                                     *
* sub0   : sous-programme commun pour la Rom HP48G(X) correspondant aux     *
*          parties de Ram # 7E000h - # 7EFFFh et # 7F000h - # 7FFFFh et     *
*          effectuant les dconfigurations, peekant un quartet puis         *
*          reconfigurant ces parties de Ram pour l'accs  la Rom cache.   *
* entre : C(A) := adresse de la Ram  dconfigurer                         *
* sortie : A(1) := le quartet peek                                         *
* sub00  : 1re dconfiguration + sub0                                      *
*          cette routine est utilise pour la Ram # 7F000h - 7FFFFh         *
*****************************************************************************

sub00    uncnfg                   * 1re dconfiguration
sub0     uncnfg                   * 1re ou 2ime dconfiguration
         a=dat1  1                * peek 1 quartet
         rstk=c                   * sauve # 7E000h ou # 7F000h
         lchex   ff000            * pour la reconfiguration des 2 modules
         config                   * reconfiguration
         c=rstk                   * restaure # 7E000h ou # 7F000h
         config                   * reconfiguration
         rtncc
end

*****************************************************************************
* trans : sauvegarde le nombre de codes  peeker et l'adresse de dbut du   *
*         code                                                              *
*         dtecte le type de Rom HP48S(X) ou HP48G(X)                       *
*         transfre la partie de programme entre start et end               *
*         dans le buffer RS232c correspondant au type de machine            *
*         entres : l'entier binaire au niveau 2 pour l'adresse du peek     *
*                   l'entier binaire n au niveau 1 pour le nombre de codes  *
*                   (quartets ou nibbles)  peeker                          *
*                   l'adresse de start sur la pile des retours              *
*                   D0 pointe sur end                                       *
*         sorties : R1(A) := nombre n de quartets  peeker                  *
*                   R2(A) := adresse dbut du code  peeker                 *
*                   dbut de ce programme transfr en                      *
*                   # 701FCh pour HP48S(X)                                  *
*                   # 80319h pour HP48G(X)                                  *
*                   ST(0) = 0 pour HP48G(X) et = 1 pour HP48S(X)            *
*                   message d'erreur "Bad Argument Value" et arrt si pour  *
*                   HP48S(X) l'adresse du peek + nombre de codes > # 80000h *
*****************************************************************************

trans    ad0ex                    * adresse fin programme (end)
         d0=a
         r0=a                     * sauvegarde cette adresse
         gosbvl  =PopASavptr      * A(A) := adresse nombre nibs, DROP, SAVPTR
         d0=a                     * @ entier binaire 1er niveau 
         d0=d0+  10
         a=dat0  a                * nombre de qartets  peeker
         r1=a                     * sauvegarde
         c=dat1  a                * adresse entier binaire 2ime niveau
         d0=c
         d0=d0+  10
         c=dat0  a                * adresse o peeker
         r2=c                     * sauvegarde
         a=a+c   a                * fin du peek pour hp48s 
         d0=(5)  #0011b
         c=dat0  a                * C(4) := 7 pour Ram interne HP48G(X)
*                                           8 pour Ram interne HP48G(X)
         st=0    0                * pour HP48G(X)
         c=c+c   a                * pour tenter de mettre Carry  1
         goc     hp48g            * si HP48G(X) 8 + 8 -> dpassement -> Carry
         st=1    0                * pour HP48S(X)         
         lchex   80000            * vrification adresse du peek + n <= 80000
         ?a<=c   a
         goyes   ok48s
badval   lc(5)   =argvalerr       * hors Rom HP48S(X) : Bad Argument Value
         govlng  =GPErrjmpC       * GETPTR et sortie avec erreur
hp48g
ok48s    a=r0                     * adresse fin programme (end)
         c=rstk                   * adresse dbut programme (start)
         d0=c                     * pour dbut mmoire  dplacer
         a=a-c   a                * fin - dbut := longueur  dplacer
         lc(5)   =uart_bufferG    * adresse buffer RS232c HP48G(X)
         ?st=0   0                * Rom HP48G(X) ?
         goyes   HP48G
         lc(5)   =uart_bufferS    * sinon adresse buffer RS232c HP48S(X)
HP48G    rstk=c                   * mise sur la pile pour excution du
*                                   programme  partir de start
         d1=c                     * pour dbut mmoire dplace
         c=a     a                * nombre de quartets  dplacer
         gosbvl  =MOVEDOWN        * dplacement
         govlng  =GETPTR          * aprs GETPTR saut  la nouvelle position
*                                   de start dans le buffer RS232c
ENDCODE
 ;
;
