/*****************************************************************************/
/*****************************************************************************/
/**                            MASKEDIT.C                                   **/
/**               Editeur de masques de remplissages pour HP95              **/
/**                            Version 1.0                                  **/
/**                                                                         **/
/**   Cration : 20/02/93                          Auteur : Jacques Belin   **/
/**   Dernire modification : Changement du nom du fichier par dfaut       **/
/**                                                                         **/
/**  Note : Dvelopp et test uniquement sur Turbo C++ 1.01                **/
/**         TASM ncessaire (pour l'assemblage en ligne de grafx95.c)       **/
/*****************************************************************************/
/*****************************************************************************/
#include <stdio.h>
#include <dos.h>
#include <io.h>
#include <conio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <bios.h>
#include <dir.h>
#include <ctype.h>
#include <sys\stat.h>
#include "grafx95.c"  /* fonctions graphiques. Voir JPC 84+correction JPC 85 */



/*--------- Codes de quelques touches tels que GetKey() les renvoie ---------*/
#define BS      8                               /* Code de touche Back-Space */
#define CR      13                                  /* Code de touche Return */
#define ESC     27                                  /* Code de touche Escape */
#define F1      315                                    /* Code de touche F1  */
#define F2      316                                    /* Code de touche F2  */
#define F3      317                                    /* Code de touche F3  */
#define F4      318                                    /* Code de touche F4  */
#define F5      319                                    /* Code de touche F5  */
#define F6      320                                    /* Code de touche F6  */
#define F7      321                                    /* Code de touche F7  */
#define F8      322                                    /* Code de touche F8  */
#define F9      323                                    /* Code de touche F9  */
#define F10     324                                    /* Code de touche F10 */
#define HOME    327                                   /* Code de touche Home */
#define UP      328                                 /* Codes de curseur haut */
#define PgUp    329                                /* Code de touche page up */
#define LEFT    331                               /* Codes de curseur gauche */
#define RIGHT   333                               /* Codes de curseur droite */
#define END     335                                    /* Code de touche Fin */
#define DOWN    336                                  /* Codes de curseur bas */
#define PgDn    337                              /* Code de touche page down */
#define DEL     339                           /* code de touche d'effacement */
#define SF2     341                               /* Code de touche Shift+F2 */

#define YES     'Y'              /* codes de retour pour la fonction yesno() */
#define NO      'N'

#define X_FILE   120                          /* position du nom du fichier  */
#define Y_FILE   1 

#define X_ZOOM   134                     /* position de la fentre d'dition */
#define Y_ZOOM   24

#define X_PATERN 20                         /* position de la fentre gauche */
#define Y_PATERN 14
#define W_PATERN 84                                 /* largeur de la fentre */
#define H_PATERN 84                                 /* hauteur de la fentre */

#define LEN_NAME 20                             /* longueur du nom du masque */
#define X_NAME   49                              /* position du nom du motif */
#define Y_NAME   102
#define W_NAME   ((LEN_NAME+2)*6)                   /* largeur de la fentre */
#define H_NAME   12                                 /* hauteur de la fentre */

#define X_LOGO   205                                 /* position du logo J*B */
#define Y_LOGO   100

#define MAX_NB_FILLS  500          /* nombre maximum de masques dans fichier */

#define LEN_FILENAME  30                  /* longueur maxi du nom du fichier */
#define DEF_FILENAME  "c:\\_dat\\masks.msk"            /* fichier par dfaut */
#define MAGIC         0x930401L         /* code de reconnaissance du fichier */

typedef struct               /* description d'un enregistrement d'un fichier */
          {
           char mask[8];                                            /* motif */
           char name[LEN_NAME+1];                                     /* nom */
          } FILL_MASK;


DESCRIPT_IMAGE(32, 17, IMAGE_32_17)               /* dfinition de structure */
                                                      /* Description du Logo */
IMAGE_32_17 logo_jb0 = {                      /* masque de dtourage du logo */
                        1, 1, 32, 17,
                        {
                        0x07, 0xf8, 0x3f, 0xe0,
                        0x07, 0xf8, 0x3f, 0xe0,
                        0x07, 0xf8, 0x3f, 0xf0,
                        0x07, 0xfb, 0xbf, 0xf0,
                        0x01, 0xe3, 0x9e, 0xf0,
                        0x01, 0xef, 0xff, 0xf0,
                        0x01, 0xef, 0xff, 0xf0,
                        0xff, 0xff, 0xff, 0xff,
                        0xff, 0xff, 0xff, 0xff,
                        0xff, 0xff, 0xff, 0xff,
                        0x01, 0xef, 0xff, 0xf0,
                        0x3d, 0xef, 0xff, 0xf0,
                        0x3d, 0xe3, 0x9e, 0xf0,
                        0x3f, 0xe3, 0xbf, 0xf0,
                        0x3f, 0xe0, 0x3f, 0xf0,
                        0x3f, 0xe0, 0x3f, 0xf0,
                        0x1f, 0xc0, 0x3f, 0xe0,
                        }
                       };

IMAGE_32_17 logo_jb1 = {                              /* logo proprement dit */
                        1, 1, 32, 17,
                        {
                        0x00, 0x00, 0x00, 0x00,
                        0x03, 0xf0, 0x1f, 0xc0,
                        0x03, 0xf0, 0x1f, 0xe0,
                        0x00, 0xc0, 0x0c, 0x60,
                        0x00, 0xc1, 0x0c, 0x60,
                        0x00, 0xc1, 0x0c, 0x60,
                        0x00, 0xc5, 0x4c, 0xc0,
                        0x00, 0x03, 0x80, 0x00,
                        0x7f, 0xff, 0xff, 0xfe,
                        0x00, 0x03, 0x80, 0x00,
                        0x00, 0xc5, 0x4c, 0xc0,
                        0x00, 0xc1, 0x0c, 0x60,
                        0x18, 0xc1, 0x0c, 0x60,
                        0x18, 0xc0, 0x0c, 0x60,
                        0x1f, 0xc0, 0x1f, 0xe0,
                        0x0f, 0x80, 0x1f, 0xc0,
                        0x00, 0x00, 0x00, 0x00,
                        }, 
                       };

                                   /* Description du Pixel pour fentre zoom */
DESCRIPT_IMAGE(8, 8, IMAGE_8_8)

IMAGE_8_8 big_pixel  = {
                        1, 1, 8, 8,                              /*  HEADER  */
                        {
                         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
                        }
                       };

                                                       /* VARIABLES GLOBALES */
int  updated = 0;             /* flag indiquant que le fichier a t modifi */
int  num_mask=0;                                  /* numro du motif courant */
int  nb_masks=0;                        /* nombres de motifs dans le fichier */
FILL_MASK curr_mask;            /* variable de travail pour le motif courant */
FILL_MASK far *masks;                  /* pointeur sur le tableau des motifs */
unsigned  int seg_m;                 /* segment de dpart du tableau "masks" */



                              /* prototypes des fonctions dclares plus bas */
void disp_help(void);
void disp_filename(char *filename);
void disp_cursor(int x, int y);
void update(void);
int  save(char *file);
int  load(char *file);

int  detect_hp95(void);
int  GetKey(void);
int  msg_box2(char *message1, char *message2, int color, char *exit_codes);
void wait_box(char *message, int color);
int  yesno_box(char *message, int color);
int  ginput(char *string, int len, int x1, int y1, int color);
int  get_in_box(char *titre, char *string, int len_string, int color);


/*****************************************************************************/
/*****************************************************************************/
/*                            Module Principal                               */
/*****************************************************************************/
/*****************************************************************************/
void main(int argc, char *argv[])
   {
    int  fin=0;                                  /* flag de fin du programme */
    int  key, key2;                                       /* codes de touche */
    int  ret;                                  /* code de retour de fonction */
    int  errflag=0;                                         /* flag d'erreur */
    int  regen;          /* flag indiquant que l'on veut regnrer le dessin */
    int  curs_x=0;                 /* position courante du curseur graphique */
    int  curs_y=0;
    char hex_code[3];                /* chaine contenant le code hexadcimal */
    char filename[LEN_FILENAME+1];                 /* nom complet du fichier */
    char new_name[LEN_FILENAME+1];     /* tampon pour nouveau nom de fichier */
    int  i, j;
    char c, c2;


    if(!detect_hp95())                  /* si l'ordinateur n'est pas un HP95 */
      {
       fprintf(stderr, "This program runs only on an HP95LX !\n");
       exit(-1);
      }

    if(argc > 2)                      /* si 2 parametres (ou plus) -> erreur */
      errflag=1;

    if(errflag == 1)                                            /* si erreur */
      {
       fprintf(stderr, "usage : maskedit  [file]\n");
       exit(-1);
      }

                                /* allocation du buffer contenant les motifs */
    if(allocmem(((sizeof(FILL_MASK)*(MAX_NB_FILLS+1))+15)/16, &seg_m) != -1)
      {
       fprintf(stderr, "Error : not enough memory to run\n");
       exit(-1);
      }
    masks = MK_FP(seg_m, 0);


    init_graph();                        /* initialisation du mode graphique */

    set_fill_mask("\x49\x92\x24\x49\x92\x24\x49\x92");  /* affichage du fond */
    draw_rectangle(239, 127, PATERN);

    set_color(CBLACK);   /* affichage des lignes hautes et basses de l'cran */
    move_pen(0, 0);
    draw_rectangle(239, 8, SOLID);
    move_pen(0, 118);
    draw_rectangle(239, 127, SOLID);
    set_color(CWHITE);
    write_text(2, 1, "FILL MASK EDITOR", 0);
    write_text(2, 119, "Hlp Sav Lod Nam Inv Ins Del         End", 0);

                                                        /* affichage du logo */
    put_image((IMAGE *) &logo_jb0, X_LOGO, Y_LOGO, INVERSE, AND); /*aff mask */
    put_image((IMAGE *) &logo_jb1, X_LOGO, Y_LOGO, NORMAL, OR);   /*aff logo */

    move_pen(X_PATERN-1, Y_PATERN-1);   /* affichage bordure fentre hachure */
    set_color(CWHITE);
    draw_rectangle(X_PATERN+W_PATERN, Y_PATERN+H_PATERN, SOLID);
    set_color(CBLACK);
    draw_rectangle(X_PATERN+W_PATERN, Y_PATERN+H_PATERN, OUTLINE);

    move_pen(X_ZOOM-10, Y_ZOOM-11);           /* affichage bordure zone zoom */
    set_color(CWHITE);
    draw_rectangle(X_ZOOM+86, Y_ZOOM+74, SOLID);
    set_color(CBLACK);
    draw_rectangle(X_ZOOM+86, Y_ZOOM+74, OUTLINE);
    move_pen(X_ZOOM-2, Y_ZOOM-2);          /* affichage bordure fentre zoom */
    set_color(CWHITE);
    draw_rectangle(X_ZOOM+63+2, Y_ZOOM+63+2, SOLID);
    set_color(CBLACK);
    draw_rectangle(X_ZOOM+63+2, Y_ZOOM+63+2, OUTLINE);

    set_color(CWHITE);                              /* Affichage fentre nom */
    move_pen(X_NAME, Y_NAME);
    draw_rectangle(X_NAME+W_NAME-1, Y_NAME+H_NAME-1, SOLID);
    set_color(CBLACK);                    
    draw_rectangle(X_NAME+W_NAME-1, Y_NAME+H_NAME-1, OUTLINE);

    if(argc == 2)                             /* si un paramtre  t donn */
       strcpy(filename, argv[1]);                     /* copie dans filename */
    else
       strcpy(filename, DEF_FILENAME);          /* sinon, fichier par dfaut */
    strcpy(new_name, DEF_FILENAME);
    load(filename);                                 /* chargement du fichier */
    disp_filename(filename);                  /* affichage du nom du fichier */

    disp_cursor(curs_x, curs_y);           /* affichage du curseur graphique */

    hex_code[2] = '\0';    /* initialisation du dernier octet d'une chaine C */
    regen = 1;                    /* autorisation de rgnration de l'cran */
    do
      {
       if(regen)                  /* si autorisation rgnration de l'cran */
         {                                   /* effacement fentre hachurage */
          move_pen(X_PATERN, Y_PATERN);
          set_color(CWHITE);
          draw_rectangle(X_PATERN+W_PATERN-1, Y_PATERN+H_PATERN-1, SOLID);
          set_color(CBLACK);
          set_fill_mask(curr_mask.mask);          /* slection nouveau motif */
                                              /* affichage nouveau hachurage */
          draw_rectangle(X_PATERN+W_PATERN-1, Y_PATERN+H_PATERN-1, PATERN);

          move_pen(X_NAME+1, Y_NAME+1);          /* effacement nom hachurage */
          set_color(CWHITE);                 
          draw_rectangle(X_NAME+W_NAME-2, Y_NAME+H_NAME-2, SOLID);
          set_color(CBLACK);                        /* affichage nouveau nom */
          write_text(X_NAME+3, Y_NAME+2, curr_mask.name, 0);

          move_pen(X_ZOOM+73, Y_ZOOM);          /* effacement des codes Hexa */
          set_color(CWHITE);
          draw_rectangle(X_ZOOM+85, Y_ZOOM+63, SOLID);
          set_color(CBLACK);
                                        /* affichage  du masque de hachurage */
          for(j=0; j<8; j++)                  /* pour chaque octet du masque */
            {
             c=curr_mask.mask[j];                           /* lecture octet */
                                             /* affichage de l'octet en Hexa */
                /*  (plus rapide que : sprintf(hex_code, "%02X", c & 0xff);) */
             c2 = c & 0xf;
             hex_code[1] = c2 > 9 ? c2-10+'A' : c2+'0';
             c2 = (c>>4) & 0xf;
             hex_code[0] = c2 > 9 ? c2-10+'A' : c2+'0';
             write_text(X_ZOOM+73, Y_ZOOM+(8*j), hex_code, 0);

             for(i=7; i>=0; i--)        /* pour chaque bit ( partir du LSB) */
               {
                put_image((IMAGE *) &big_pixel, X_ZOOM+(i*8),    /*aff pixel */
                                  Y_ZOOM+(j*8), c & 1, FORCE);
                c >>= 1;                                      /* bit suivant */
               }
            }
         }

       regen = 0;
       key=GetKey();                     /* acquisition du code de la touche */
       switch(key)                           /* suivant le code de la touche */
         {
          case PgUp  : update();
                       if(num_mask > 0)  /*positionnement sur motif prcdent*/
                         {
                          num_mask--;
                          memcpy(&curr_mask, &masks[num_mask], 
                                                          sizeof(FILL_MASK));
                          regen = 1;
                         }
                       break;

          case CR    : 
          case PgDn  : update();                            /* motif suivant */
                       if(num_mask < nb_masks)
                         {
                          num_mask++;
                          memcpy(&curr_mask, &masks[num_mask], 
                                                          sizeof(FILL_MASK));
                          regen = 1;
                         }
                       break;

          case HOME  : update();         /* positionnement sur premier motif */
                       num_mask = 0;          
                       memcpy(&curr_mask, &masks[num_mask], 
                                                          sizeof(FILL_MASK));
                       regen = 1;
                       break;

          case END   : update();           /* positionnement sur fin fichier */
                       num_mask = nb_masks;
                       memcpy(&curr_mask, &masks[num_mask], 
                                                          sizeof(FILL_MASK));
                       regen = 1;
                       break;

          case LEFT  : curs_x--;      /* dplacement pointeur vers la gauche */
                       if(curs_x < 0)
                          curs_x = 7;
                       disp_cursor(curs_x, curs_y);
                       break;

          case RIGHT : curs_x++;      /* dplacement pointeur vers la droite */
                       if(curs_x == 8)
                          curs_x = 0;
                       disp_cursor(curs_x, curs_y);
                       break;

          case UP    : curs_y--;        /* dplacement pointeur vers le haut */
                       if(curs_y < 0)
                          curs_y = 7;
                       disp_cursor(curs_x, curs_y);
                       break;

          case DOWN  : curs_y++;         /* dplacement pointeur vers le bas */
                       if(curs_y == 8)
                          curs_y = 0;
                       disp_cursor(curs_x, curs_y);
                       break;

          case ' '   :
          case DEL   : c=curr_mask.mask[curs_y];  /* inversion du bit point */
                       i = 7-curs_x;
                       c =  c ^ (1 << i);
                       curr_mask.mask[curs_y]=c;
                       regen = 1;
                       break;

                                                 /* retour au motif original */
          case ESC   : memcpy(&curr_mask, &masks[num_mask], 
                                                          sizeof(FILL_MASK));
                       regen = 1;
                       break;

          case F1    : disp_help();           /* Affichage de l'cran d'aide */
                       break; 

          case F2    : update();                               /* sauvegarde */
                       if(updated)
                          save(filename);
                       break; 

          case SF2   : strcpy(new_name, filename);     /* sauvegarde sous... */
                       key2 = get_in_box("Save Under...", new_name, 
                                                       LEN_FILENAME, CWHITE);
                       if(key2 != ESC)            /* si touche sortie != ESC */
                         {
                          update();
                          strcpy(filename, new_name); 
                          save(filename);     /* sauvegarde sous nouveau nom */
                          disp_filename(filename);
                          regen = 1;
                         }
                       break;

                                                  /* chargement d'un fichier */
          case F3    : strcpy(new_name, filename);
                       key2 = get_in_box("Load File...", new_name, 
                                                       LEN_FILENAME, CWHITE);
                       if(key2 != ESC)         /* si touche de sortie != ESC */
                         {
                          update();
                          if(updated)          /* si fichier courant modifi */
                            {
                             if(yesno_box("DO YOU WANT TO SAVE ?", CWHITE)
                                   == YES)
                                save(filename);
                            }
                          if(load(new_name) == 0)      /* chargement fichier */
                            {
                             strcpy(filename, new_name);  /*aff. nom fichier */
                             disp_filename(filename);
                            }
                          regen = 1;
                         }
                       break;

                                             /* modification du nom du motif */
          case F4    : ginput(curr_mask.name, LEN_NAME, X_NAME+3,
                                                          Y_NAME+2, CBLACK);
                       regen = 1;
                       break;

          case F5    : for(i=0; i<8; i++)              /* inversion du motif */
                          curr_mask.mask[i] = (char) ~curr_mask.mask[i];
                       regen = 1;
                       break;

                                                     /* insertion d'un motif */
          case F6    : if(nb_masks == MAX_NB_FILLS) /* si nbre maxi de masks */
                         {                                     /* ...atteint */
                          wait_box("Maximum number of masks reached !", 
                                                                      CBLACK);
                         }
                       else                                         /* sinon */
                         {
                          if(num_mask != nb_masks)   /* insertion d'un motif */
                            { 
                             update();
                                          /* deplacement des motifs suivants */
                             for(i=nb_masks; i>=num_mask; i--)  
                               memcpy(&masks[i+1], &masks[i], 
                                                           sizeof(FILL_MASK));
                             nb_masks++;           /* incr. nombre de motifs */
                             memset(&curr_mask, 0, sizeof(FILL_MASK));
                             memset(&masks[num_mask], 0, sizeof(FILL_MASK));
                             updated = 1;
                             regen = 1;
                            }
                         }
                       break;

                                                    /* effacement d'un motif */
          case F7    : if((nb_masks != 0) && (num_mask != nb_masks))
                         {                    /* deplacement motifs suivants */
                          for(i=num_mask; i<=nb_masks; i++)  
                            memcpy(&masks[i], &masks[i+1], sizeof(FILL_MASK));
                          nb_masks--;     /* decrmentation nombre de motifs */
                          memcpy(&curr_mask, &masks[num_mask], 
                                                          sizeof(FILL_MASK));
                          updated = 1;
                          regen = 1;
                         }
                       break;

                                                         /* fin de programme */
          case F10   : if(yesno_box("DO YOU REALLY WANT TO QUIT ?", CBLACK)
                                   == YES)
                         {
                          update();
                          if(updated)                  /* si fichier modifi */
                            {
                             if(yesno_box("DO YOU WANT TO SAVE ?", CWHITE)
                                   == YES)
                                save(filename);
                            }
                          fin=1;                         /* fin du programme */
                         }
                       break;

          default    : regen = 0;                          /* autres touches */
                       break;
         }
      }
    while(!fin);        /* boucle tant que la touche F10 n'a pas t presse */

    exit_graph();                                    /* retour en mode texte */

    freemem(seg_m);          /* lib. mmoire utilise par le tableau "masks" */

    printf("MASKEDIT Version 1.00\n");
   }


/*****************************************************************************/
/* DISP_HELP : Affiche l'cran d'aide                                        */
/* Entres : Aucune                                                          */
/* valeur retourne : Aucune                                                 */
/*****************************************************************************/
void disp_help(void)
   {
    GRAPHINFO95 grinfo;               /* sauvegardes des paramtres initiaux */
    unsigned seg;                         /* segment du buffer de sauvegarde */
    IMAGE *buff_box;                         /* pointeur sur le buffer image */
    int len_mess1;                                  /* longueur des messages */
    int len_mess2;

    get_graph_info(&grinfo);           /* sauvegarde des paramtres courants */

            /* annulation des paramtres peut-tre modifis par le programme */
    set_logorigin(0, 0); 
    set_clip_region(0, 0, 239, 127);
    set_line_type(SOLID_LINE);
    set_rule(FORCE);

    allocmem((LEN_IMAGE(240, 128)+15)/16 , &seg);      /* creation du buffer */
    buff_box = (IMAGE *) MK_FP(seg, 0);

    get_image(buff_box, 0, 9, 240, 109);             /* sauvegarde ds buffer */

    set_logorigin(0, 9);          /*prendre coin de la fentre comme origine */
    move_pen(0, 0);
    set_color(CWHITE);
    draw_rectangle(239, 108, SOLID);         /* on affiche la fentre (vide) */
    set_color(CBLACK);
    draw_rectangle(239, 108, OUTLINE);             /* on affiche une bordure */

                                              /* affichage de l'ecran d'aide */
    write_text(3,   3, "Page Up/Down : Previous/Next Fill Mask.", 0);
    write_text(3,  11, "Home/End     : First/Last Fill Mask.",    0);
    write_text(3,  19, "Space or Del : Inverse a pixel",          0);
    write_text(3,  27, "ESC          : Cancel the changes",       0);
    write_text(3,  35, "F1           : Help about the keys.",     0);
    write_text(3,  43, "F2           : Save the current file.",   0);
    write_text(3,  51, "Shift F2     : Save under a new name.",   0);
    write_text(3,  59, "F3           : Load a file.",             0);
    write_text(3,  67, "F4           : Edit the Fill Mask Name.", 0);
    write_text(3,  75, "F5           : Inverse the patern.",      0);
    write_text(3,  83, "F6           : Insert a new Fill Mask.",  0);
    write_text(3,  91, "F7           : Delete the current Mask.", 0);
    write_text(3,  99, "F10          : Quit the program",         0);

    GetKey();
                                                 /* effacement de la fentre */
    set_logorigin(0, 0);
    put_image(buff_box, 0, 9, NORMAL, FORCE);       /* raffichage prcdent */
    freemem(seg);         /* libration de la mmoire utilise par le buffer */

                                          /* restauration valeurs originales */
    set_logorigin(grinfo.col_orig, grinfo.row_orig); 
    move_pen(grinfo.pen_col, grinfo.pen_row);
    set_clip_region(grinfo.left_clip, grinfo.top_clip, 
                    grinfo.right_clip, grinfo.bottom_clip);
    set_line_type(grinfo.line_type);
    set_color(grinfo.color);
    set_rule(grinfo.rep_rule);
   }


/*****************************************************************************/
/* DISP_FILENAME : Affichage du nom du fichier                               */
/* Entre  : filename = nom du fichier (avec path, eventuellement)           */
/* Sortie  : Aucune                                                          */
/* NOTE    : par souci de scurit et de simplicit, resort toujours         */
/*           avec couleur courante CBLACK                                    */
/*****************************************************************************/
void disp_filename(char *filename)
   {
    char string[20];                      /* chaine transmise  write_text() */
    char drive[MAXDRIVE];               /* variables utilises par fnsplit() */
    char dir[MAXDIR];
    char name[MAXFILE];                       /* nom et extension du fichier */
    char ext[MAXEXT];

    strupr(filename);
    fnsplit(filename, drive, dir, name, ext);
    move_pen(X_FILE, Y_FILE);
    set_color(CBLACK);
    draw_rectangle(X_FILE+(6*19), Y_FILE+6, SOLID);
    set_color(CWHITE);
    sprintf(string, "File : %s%s", name, ext);
    write_text(X_FILE, Y_FILE, string, NORMAL);
    set_color(CBLACK);
   }


/*****************************************************************************/
/* DISP_CURSOR : affichage du pointeur de la fentre zoom                    */
/* Entre  : x, y = coordonnes du pointeur (x, y = [0..7])                  */
/* Sortie  : Aucune                                                          */
/*****************************************************************************/
void disp_cursor(int x, int y)
   {
    int x1, y1;             /* coordonnes cran du bit dans la fentre zoom */

    x1 = X_ZOOM + 3 + (8*x);              /* conversion en coordonnes ecran */
    y1 = Y_ZOOM + 3 + (8*y);

    set_color(CWHITE);
    move_pen(X_ZOOM-8, Y_ZOOM);                 /* effacement curseur gauche */
    draw_rectangle(X_ZOOM-4, Y_ZOOM+63, SOLID);
    move_pen(X_ZOOM+63+4, Y_ZOOM);               /* effacement curseur droit */
    draw_rectangle(X_ZOOM+63+4+4, Y_ZOOM+63, SOLID);
    move_pen(X_ZOOM, Y_ZOOM-9);                   /* effacement curseur haut */
    draw_rectangle(X_ZOOM+63, Y_ZOOM-4, SOLID);
    move_pen(X_ZOOM, Y_ZOOM+63+4);                 /* effacement curseur bas */
    draw_rectangle(X_ZOOM+63, Y_ZOOM+63+4+5, SOLID);

    set_color(CBLACK);
    move_pen(X_ZOOM-8, y1);                          /* trac curseur gauche */
    draw_rectangle(X_ZOOM-4, y1+1, SOLID);
    move_pen(X_ZOOM+63+4, y1);                        /* trac curseur droit */
    draw_rectangle(X_ZOOM+63+4+4, y1+1, SOLID);
    move_pen(x1, Y_ZOOM-9);                            /* trac curseur haut */
    draw_rectangle(x1+1, Y_ZOOM-4, SOLID);
    move_pen(x1, Y_ZOOM+63+4);                          /* trac curseur bas */
    draw_rectangle(x1+1, Y_ZOOM+63+4+5, SOLID);
   }


/*****************************************************************************/
/* UPDATE  : mise  jour du tableau masks                                    */
/* Entre  : Aucune                                                          */
/* Sortie  : Aucune                                                          */
/*****************************************************************************/
void update(void)
   {
    if(num_mask >= MAX_NB_FILLS)     /* si masque dit est le dernier et ...*/
      {           /* ...que son numro est plus grand que le maxi admissible */
       wait_box("Maximum number of masks reached !", CBLACK);
      }
    else                                                       /* cas normal */
      {
       if(memcmp(&curr_mask, &masks[num_mask],           /* si motif modifi */
                         sizeof(FILL_MASK)) != 0)
      {                           /* sauvegarde du motif courant dans buffer */
          memcpy(&masks[num_mask], &curr_mask, sizeof(FILL_MASK));
          updated = 1;
          if(num_mask == nb_masks)          /* si cration du dernier masque */
             nb_masks++;                 /* incrmentation nombre de masques */
         }
      }
   }


/*****************************************************************************/
/* LOAD    : Lecture du fichier                                              */
/* Entres : file = nom du fichier                                           */
/* Sortie  : 0 si tout s'est bien pass                                      */
/*****************************************************************************/
int load(char *filename)
   {
    int  fd;                                     /* handle du fichier ouvert */
    int errflag = 0;                                        /* flag d'erreur */
    long magic;                         /* code de reconnaissance du fichier */

    fd = open(filename, O_RDONLY+O_BINARY);          /* ouverture du fichier */
    if(fd == -1)                               /* si le fichier n'existe pas */
      {
       memset(masks, 0, sizeof(FILL_MASK)*(MAX_NB_FILLS+1));/*init buffer  0*/ 
       memcpy(&curr_mask, &masks[0], sizeof(FILL_MASK));
       nb_masks = 0;
       num_mask = 0;
       updated = 0;
      } 
    else                                         /* sinon, on lit le fichier */
      {
       read(fd, &magic, sizeof(long));         /* lecture en-tte du fichier */
       if(magic != MAGIC)  /* si en-tte diffrent du code de reconnaissance */
         {
          errflag = 1;                        /* ce n'est pas le bon fichier */
         }
       else
         {
          memset(masks, 0, sizeof(FILL_MASK)*(MAX_NB_FILLS+1)); /*eff. buffer*/
          nb_masks = 0;
                                                       /* lecture du fichier */
          while(read(fd, &masks[nb_masks], sizeof(FILL_MASK)) 
                                                        == sizeof(FILL_MASK))
             nb_masks++;
          memcpy(&curr_mask, &masks[0], sizeof(FILL_MASK));
          num_mask = 0;
          updated = 0;
         }
       if(errflag)                                   /* si erreur de lecture */
         {
          wait_box("Error : Invalid Masks File", CBLACK);
         }
      }
    close(fd);                                       /* fermeture du fichier */
    return(errflag);
   }


/*****************************************************************************/
/* SAVE    : Sauvegarde du fichier                                           */
/* Entres : file = nom du fichier                                           */
/* Sortie  : 0 si tout s'est bien pass                                      */
/*****************************************************************************/
int save(char *file) 
   { 
    int fd;                                            /* handler du fichier */
    long magic=MAGIC;                   /* code de reconnaissance du fichier */
    int errflag = 0;
    int i;
                     
    fd = _creat(file, FA_ARCH);                       /* cration du fichier */
    if(fd != -1)
      {                                /* ecriture du code de reconnaissance */
       if(write(fd, &magic, sizeof(long)) != sizeof(long))
          errflag = 1; 
       if(!errflag)                                       /* si pas d'erreur */
         {
          for(i = 0; (i<nb_masks) && !errflag; i++)  /* pour tous les motifs */
            {
             if(write(fd, &masks[i], sizeof(FILL_MASK)) != sizeof(FILL_MASK))
               errflag=1;
            }
         }
       if(errflag)                     /* si il y a eu une erreur d'criture */
          wait_box("Error : cannot write file", CBLACK);
       else
          updated = 0;
      }
    close(fd);                                       /* fermeture du fichier */
    return(errflag);
   }



/*****************************************************************************/
/*****************************************************************************/
/**            FONCTIONS REUTILISABLES dans un autre programme              **/
/*****************************************************************************/
/*****************************************************************************/


/*****************************************************************************/
/**  DETECT_HP95 : detection d'excution du programme sur HP95              **/
/**  Entres  : aucune                                                      **/
/**  sortie   : 1 si HP-95 trouv                                           **/
/*****************************************************************************/
int detect_hp95(void)
   {
    union REGS regs;
    int retour=0;

    regs.x.ax= 0x4dd4;                      /* fonction BIOS spcifique HP95 */
    int86(0x15, &regs, &regs);
                                   /* valeurs de retour dfinis pour le HP95 */
    if((regs.h.bh == 'H') && (regs.h.bl == 'P') && (regs.h.ch == 0x01))
       retour=1;

    return(retour);
   }


/*****************************************************************************/
/* GETKEY  : lecture d'un caractre au clavier                               */
/* Entre  : Aucune                                                          */
/* Sortie  : Code de touche reue         < 256 : touche normale             */
/*                                       >= 256 : touche tendue             */
/*****************************************************************************/
int  GetKey(void)
   {
    union REGS Register;  /* Variable de registres pour appel d'interruption */

    do
      {
       Register.h.ah = 2;       /* Numro de fonction pour Lire tat clavier */
       int86(0x16, &Register, &Register);    /* Appeler int. clavier du BIOS */
      }
    while(!bioskey(1));               /* Rpter jusqu' ce que touche prte */
    Register.h.ah = 0;                    /* N de fonction pour Lire touche */
    int86(0x16, &Register, &Register);  /* Appeler interruption clavier BIOS */
    return((Register.h.al) ? Register.h.al : Register.h.ah | 256);
   }


/*****************************************************************************/
/* MSG_BOX2: Affichage d'une fentre de message de deux lignes, avec attente */
/*           de pression de touche.                                          */
/* Entres : message1 = chaine contenant texte 1ere ligne (35 caract. maxi)  */
/*           message2 = chaine contenant texte 2eme ligne (35 caract. maxi)  */
/*           color : couleur du fond de la fentre                           */
/*           exit_codes = chaine contenant les caractres autorisant la      */
/*                        sortie (chaine vide si attente de touche simple).  */
/*                        Touches de fonctions non autorises                */
/* valeur retourne : code de touche ayant provoqu la sortie                */
/*****************************************************************************/
int msg_box2(char *message1, char *message2, int color, char *exit_codes)
   {
    int color_text;                                      /* couleur du texte */
    int code;                                           /* code de la touche */
    GRAPHINFO95 grinfo;               /* sauvegardes des paramtres initiaux */
    int x_box;                                  /* Coordonnes de la fentre */
    int y_box=64-16;   
    int w_box;                            /* largeur de la fentre en pixels */
    int h_box=32;                         /* hauteur de la fentre en pixels */
    unsigned seg;                         /* segment du buffer de sauvegarde */
    IMAGE *buff_box;                         /* pointeur sur le buffer image */
    int len_mess1;                                  /* longueur des messages */
    int len_mess2;

    color_text = (color == CWHITE) ? CBLACK : CWHITE;  

    get_graph_info(&grinfo);           /* sauvegarde des paramtres courants */

            /* annulation des paramtres peut-tre modifis par le programme */
    set_logorigin(0, 0); 
    set_clip_region(0, 0, 239, 127);
    set_line_type(SOLID_LINE);
    set_rule(FORCE);

    len_mess1 = strlen(message1); 
    len_mess2 = strlen(message2);
    w_box = (max(len_mess1, len_mess2) + 4) * 6;   /* calcul largeur fentre */
    x_box = 120 - (w_box/2);                       /* centrage de la fentre */

    allocmem((LEN_IMAGE(w_box, h_box)+15)/16 , &seg);  /* creation du buffer */
    buff_box = (IMAGE *) MK_FP(seg, 0);

    get_image(buff_box, x_box, y_box, w_box, h_box); /* sauvegarde ds buffer */

    set_logorigin(x_box, y_box);  /*prendre coin de la fentre comme origine */
    set_color(color);
    move_pen(0, 0);
    draw_rectangle(w_box-1, h_box-1, SOLID);   /*on affiche la fentre (vide)*/
    set_color(color_text);
    draw_rectangle(w_box-1, h_box-1, OUTLINE);     /* on affiche une bordure */
    set_line_type(DOTTED_LINE);
    move_pen(3, 3);
    draw_rectangle(w_box-4, h_box-4, OUTLINE);  /* un cadre, pour faire joli */
    move_pen(0, 0);
    write_text((w_box-(len_mess1*6)) / 2,  8, message1, 0); /*affichage texte*/
    write_text((w_box-(len_mess2*6)) / 2, 17, message2, 0);

    if(strlen(exit_codes) == 0)          /* si aucun code de sortie spcifi */
      {                          /* on sortira aprs n'importe quelle touche */
       GetKey();                            /* attente de pression de touche */
       code = 0;               
      }
    else           /* sinon, on ne sortira qu'aprs une pression sur une ... */
      {                                /* ... touche dfinie dans exit_codes */
       do
         {
          code=GetKey();                    /* attente de pression de touche */
          if(islower(code))          /* conversion des caractres minuscules */
             code=_toupper(code); 
         }
       while(strrchr(exit_codes, code) == NULL); /* tant que code de sortie..*/
      }                                                      /* ..non activ */

                                                 /* effacement de la fentre */
    set_logorigin(0, 0);
    put_image(buff_box, x_box, y_box, NORMAL, FORCE); /*raffichage prcdent*/
    freemem(seg);         /* libration de la mmoire utilise par le buffer */

                                          /* restauration valeurs originales */
    set_logorigin(grinfo.col_orig, grinfo.row_orig); 
    move_pen(grinfo.pen_col, grinfo.pen_row);
    set_clip_region(grinfo.left_clip, grinfo.top_clip, 
                    grinfo.right_clip, grinfo.bottom_clip);
    set_line_type(grinfo.line_type);
    set_color(grinfo.color);
    set_rule(grinfo.rep_rule);

    return(code);
   }


/*****************************************************************************/
/* WAIT_BOX: Affichage d'une fentre de message de deux lignes, avec attente */
/*           de pression de touche.                                          */
/* Entres : message = chaine contenant texte 1ere ligne (35 caract. maxi)   */
/*           color : couleur du fond de la fentre                           */
/* valeur retourne : aucune                                                 */
/*****************************************************************************/
void wait_box(char *message, int color)
   {
    msg_box2(message, "Press any key", color, "");
   }

   
/*****************************************************************************/
/* YESNO_BOX : Affichage d'une fentre de message, avec attente de pression  */
/*           de touche Y ou N.                                               */
/* Entres : message = chaine contenant le texte du message (35 caract. maxi)*/
/*           color : couleur du fond de la fentre                           */
/* valeur retourne : 'Y' ou 'N'                                             */
/*****************************************************************************/
int yesno_box(char *message, int color)
   {
    return(msg_box2(message, "Press Y or N", color, "YN"));
   }
   

/*****************************************************************************/
/**  GINPUT  : entre d'une chaine de caractres en mode graphique          **/
/**  Entres  : string = chaine recevant les donnes (peut-tre dj init.) **/
/**             len = longueur maximum de la chaine                         **/
/**             x, y = Position de la chaine (Coin sup/gauche 1er caractre)**/
/**             color = couleur du fond de la fentre                       **/
/**  sortie   : code de la touche ayant provoqu la sortie                  **/
/*****************************************************************************/
                                                   /* Description du Curseur */
DESCRIPT_IMAGE(7, 8, IMAGE_7_8)
                                                /* Curseur en mode Overwrite */
IMAGE_7_8 curs_overw = {
                        1, 1, 7, 8,                              /*  HEADER  */
                        {
                         0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff
                        }
                       };
                                                /* Curseur en mode Insertion */
IMAGE_7_8 curs_ins   = {
                        1, 1, 7, 8,                              /*  HEADER  */
                        {
                         0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff
                        }
                       };

int  Insert;                /* flag indiquant que l'on est en mode insertion */

int ginput(char *string, int len, int x, int y, int color)
   {
    char str_init[80];                      /* stockage de la chaine intiale */
    int curpos2=0;                                    /* position du curseur */
    int color_text;                                      /* couleur du texte */
    GRAPHINFO95 grinfo;              /* sauvegarde des paramtres graphiques */
    union REGS Register;  /* Variable de registres pour appel d'interruption */
    int  Ins;                                      /* flag de mode insertion */
    int j, key, fin;

    strcpy(str_init, string);                 /* sauvegarde chaine originale */
    color_text = (color == CWHITE) ? CBLACK : CWHITE;

    get_graph_info(&grinfo);           /* sauvegarde des paramtres courants */

    set_rule(FORCE);

    move_pen(x-2, y-1);       /* curseur en haut/droite de la zone d'edition */

    *((unsigned far *) MK_FP(0x40, 0x17)) &= 63;    /* force INS et CAPS  0 */
    Insert = 0;

    fin=0;
    do
      {
       set_color(color);                    /* effacement du texte prcdent */
       draw_rectangle(x+(6*(len+1))+1, y+8, SOLID);
       set_color(color_text);                  /* affichage du nouveau texte */
       write_text(x, y, string, 0);    

       Insert = 2;                        /* on force l'affichage du curseur */
       do
         {
          Register.h.ah = 2;    /* Numro de fonction pour Lire tat clavier */
          int86(0x16, &Register, &Register);  /*Appeler int. clavier du BIOS */
          Ins = (Register.h.al & 128) ? 1 : 0;     /* lecture mode insertion */
          if(Ins != Insert)                     /* si mode insertion modifi */
            {
             Insert = Ins;       
             if(Insert)                              /* affichage du curseur */
                put_image((IMAGE *) &curs_ins, x+(6*curpos2), y, NORMAL, XOR);
             else
                put_image((IMAGE *) &curs_overw, x+(6*curpos2), y, 
                                                                NORMAL, XOR);
            }
         }
       while(!bioskey(1));            /* Rpter jusqu' ce que touche prte */
       Register.h.ah = 0;                 /* N de fonction pour Lire touche */
       int86(0x16, &Register, &Register); /*Appeler interruption clavier BIOS*/
       key = (Register.h.al) ? Register.h.al : Register.h.ah | 256;
   
       if((key>31) && (key<255))                    /* si caractere editable */
         {
          if(curpos2 != len)                 /* si curpos diff. de long. max */
            {
             if(Insert)                          /* si mode Insertion activ */
               {
                                          /* si long. chaine diff. long. max */
                if(strlen(string) != len)
                  {
                   for(j=len; j>=curpos2; j--)              /* inserer caract*/
                      string[j]=string[j-1];
                   string[curpos2]=key;
                   curpos2++;                            /* deplacer curseur */
                  }
               }
             else                                                   /* sinon */
               {
                if(curpos2 == strlen(string))           /* si dernier caract */
                   string[curpos2+1]='\0';             /* terminer avec '\0' */
                string[curpos2]=key;
                curpos2++;                               /* deplacer curseur */
               }
            }
         }
       else                                     /* si caractere non ditable */
         {
          switch(key)                      /* suivant la valeur de la touche */
            {
             case BS    : if(curpos2 != 0)  /* si on peut effacer un caract. */
                            {                     /* decalage vers la gauche */
                             for(j=curpos2; j<=len; j++)
                                string[j-1]=string[j];
                             curpos2--;          /* repositionnement curseur */
                            }
                          break;

             case DEL   : if(curpos2 != strlen(string))
                            {                     /* decalage vers la gauche */
                             for(j=curpos2; j<=len; j++)
                                string[j]=string[j+1];
                            }
                          break;

             case LEFT  : if(curpos2 != 0)   /* deplacement curseur a gauche */
                             curpos2--;
                          break;
                                          /* deplacement du curseur  droite */
             case RIGHT : if(curpos2 < strlen(string))
                             curpos2++;
                          break;
                                                 /* curseur en fin de chaine */
             case END   : curpos2 = strlen(string); 
                          break;

             case HOME  : curpos2 = 0;       /* deplacement curseur a gauche */
                          break;

                                                            /* si touche ESC */
             case  ESC  : if(strcmp(string, str_init) == 0) 
                             fin = 1;        /* si chaine originale, on sort */
                          else                                   /* sinon... */
                            {              /* ...on affiche chaine originale */
                             strcpy(string, str_init);
                             if(curpos2 > strlen(string))
                                curpos2 = strlen(string);
                            }
                          break;

             case  CR   : fin=1;                 /* si touche Entre presse */
                          break;

             default   :  break;                           /* autres touches */
            }
         }
      }
    while(!fin);            /* boucle tant que CR ou ESC n'a pas t presse */

    *((unsigned far *) MK_FP(0x40, 0x17)) &= 63;    /* force INS et CAPS  0 */

    move_pen(grinfo.pen_col, grinfo.pen_row);
    set_rule(grinfo.rep_rule);


    return(key);
   }


/*****************************************************************************/
/* GET_IN_BOX : Entre d'un chaine de caractres dans une fentre            */
/* Entres : titre = titre de la fentre                                     */
/*           string = chaine  ecrire                                        */
/*           len_string = longueur maximale de la chaine                     */
/*           color : couleur du fond de la fentre                           */
/* valeur retourne : code de touche ayant provoqu la sortie                */
/*****************************************************************************/
int get_in_box(char *titre, char *string, int len_string, int color)
   {
    int color_text;                                      /* couleur du texte */
    int code;                                           /* code de la touche */
    GRAPHINFO95 grinfo;               /* sauvegardes des paramtres initiaux */
    int x_box;                                  /* Coordonnes de la fentre */
    int y_box=64-16;   
    int w_box;                            /* largeur de la fentre en pixels */
    int h_box=32;                         /* hauteur de la fentre en pixels */
    unsigned seg;                         /* segment du buffer de sauvegarde */
    IMAGE *buff_box;                         /* pointeur sur le buffer image */
    int len_titre;                                  /* longueur des messages */

    color_text = (color == CWHITE) ? CBLACK : CWHITE;  

    get_graph_info(&grinfo);           /* sauvegarde des paramtres courants */

            /* annulation des paramtres peut-tre modifis par le programme */
    set_logorigin(0, 0); 
    set_clip_region(0, 0, 239, 127);
    set_line_type(SOLID_LINE);
    set_rule(FORCE);

    len_titre = strlen(titre); 
    w_box = (max(len_titre, len_string) + 4) * 6;  /* calcul largeur fentre */
    x_box = 120 - (w_box/2);                       /* centrage de la fentre */

    allocmem((LEN_IMAGE(w_box, h_box)+15)/16 , &seg);  /* creation du buffer */
    buff_box = (IMAGE *) MK_FP(seg, 0);

    get_image(buff_box, x_box, y_box, w_box, h_box); /* sauvegarde ds buffer */

    set_logorigin(x_box, y_box);  /*prendre coin de la fentre comme origine */
    set_color(color);
    move_pen(0, 0);
    draw_rectangle(w_box-1, h_box-1, SOLID);   /*on affiche la fentre (vide)*/
    set_color(color_text);
    draw_rectangle(w_box-1, h_box-1, OUTLINE);     /* on affiche une bordure */
    set_line_type(DOTTED_LINE);
    move_pen(3, 3);
    draw_rectangle(w_box-4, h_box-4, OUTLINE);  /* un cadre, pour faire joli */
    move_pen(0, 0);
    write_text((w_box-(len_titre*6)) / 2,  5, titre, 0);  /* affichage titre */

    code = ginput(string, len_string, ((w_box-(len_string*6)) / 2)-3, 
                                                             16, color_text);

                                                 /* effacement de la fentre */
    set_logorigin(0, 0);
    put_image(buff_box, x_box, y_box, NORMAL, FORCE); /*raffichage prcdent*/
    freemem(seg);         /* libration de la mmoire utilise par le buffer */

                                          /* restauration valeurs originales */
    set_logorigin(grinfo.col_orig, grinfo.row_orig); 
    move_pen(grinfo.pen_col, grinfo.pen_row);
    set_clip_region(grinfo.left_clip, grinfo.top_clip, 
                    grinfo.right_clip, grinfo.bottom_clip);
    set_line_type(grinfo.line_type);
    set_color(grinfo.color);
    set_rule(grinfo.rep_rule);

    return(code);
   }
