/*****************************************************************************/
/*****************************************************************************/
/**                            INFODIR.C                                    **/
/**              Donne les informations sur un fichier LIF                  **/
/**                                                                         **/
/**    Cration : 20/10/90               Auteur : JB                        **/
/**    Derniere modification : 05/02/91                                     **/
/**       modifcation des textes affichs                                   **/
/*****************************************************************************/
/*****************************************************************************/
              /* normalisation de country,  inclure avant "#include <dos.h>" 
                            si utilisation de cette structure avec TURBO C++ */
#define COUNTRY country   

#include "lif.c"

#if defined(__TURBOC__)
#include "lif.tc"
#else
#include "lif.msc"
#endif


void main(int argc, char *argv[])
   {
    int    lif_drive;           /* numro du lecteur de disquette (0=A, 1=B) */
    int    err_entry=0;                /* flag d'erreur entre de parametres */
    LIFDIR dir;                 /* structure contenant l'entre du directory */
    int    pos_dir=0;                     /* numro de l'entre du directory */
    char   lif_name[11];                                   /* nom du fichier */
    int    type;                                  /* code du type de fichier */
    int    private, secure; /* codes de scurit et privatisation du fichier */
    GDH    gdh;                    /* structure contenant la date du fichier */
    long   imp1, imp2; /*codes specifiques aux types de fich. dans directory */
    int    long_file;          /* longueur du fichier LIF en enregistrements */
    int    first_sect;              /* premier enregistrement du fichier LIF */
    int    retour;             /*codes de retour des fct de lecture/ecriture */
    long   long_bytes;
    char   typef[8];
    struct country c_country;    /* structure contenant le format de la date */ 
    int    i;


    if(argc != 2)                                /* un paramtre obligatoire */
      {
       err_entry=1;
      }
    else
      {
       if((argv[1][0] < '0') || (argv[1][0] > '1')) /* numro lecteur oblig. */
          err_entry=1;
      }
    if(err_entry)                                     /* si erreur en entre */
      {
       fprintf(stderr, "usage : lifbr drive_number:infile\n");
       exit(-1);
      }

    lif_drive=(int) argv[1][0]-'0';               /* dcomposition paramtre */
    strcpy(lif_name, argv[1]+2);

                                      /* mise en forme du nom du fichier LIF */
    for(i=strlen(lif_name); i<10; i++)
       lif_name[i]=' ';
    lif_name[10]='\0';

    init_dsk();                    /* initialisation du lecteur de disquette */

    retour=read_dsk(lif_drive, 0, buff_sect); /* controle validit disquette */
    if(retour)
      {
       fprintf(stderr, "Error : Not a LIF disk\n");
       fin(-1);
      }

                                            /* recherche entre du directory */
    retour=sch_dir(lif_drive, lif_name, &pos_dir, &dir);
    if(retour == -1)
      {
       fprintf(stderr, "file %s not found\n", lif_name);
       fin(-1);
      }

    if(retour == -2)
      {
       fprintf(stdout, "file %s deleted (directory=%d)", lif_name, pos_dir);
       fin(0);
      }

                                   /* dcomposition de l'entre du directory */
    break_dir(lif_name, &private, &secure, &type, &first_sect, &long_file,
                                                &gdh, &imp1, &imp2, &dir);

    switch(type)                          /* calcul des longueur de fichiers */
      {
       case 0      : strcpy(typef, "dddddd");              /* fichier effac */
                     long_bytes=long_file*256L;           /* calcul longueur */
                     break;

       case TEXT   : strcpy(typef, "TEXT  ");
                     long_bytes=long_file*256L;
                     break;

       case SDATA  : strcpy(typef, "SDATA ");
                     long_bytes=imp1;
                     break;

       case DATA   : strcpy(typef, "DATA  ");
                     long_bytes=imp1*imp2;
                     break;

       case FORTH  : strcpy(typef, "FORTH ");
                     long_bytes=(long) imp1/2;
                     break;

       case BIN    : strcpy(typef, "BIN   ");
                     long_bytes=(imp1-11L)/2;
                     break;

       case LEX    : strcpy(typef, "LEX   ");
                     long_bytes=(imp1+1L)/2;
                     break;

       case KEY    : strcpy(typef, "KEY   ");
                     long_bytes=(imp1+1L)/2;
                     break;

       case BASIC  : strcpy(typef, "BASIC ");
                     long_bytes=(imp1-11L)/2;
                     break;

       case ROM71  : strcpy(typef, "ROM71 ");
                     long_bytes=(long) imp1/2;
                     break;

       case APPT   : strcpy(typef, "APPT  ");
                     long_bytes=(long) imp1/2;
                     break;

       case GRAPH  : strcpy(typef, "GRAPH ");
                     long_bytes=(imp1-10L)/2;
                     break;

       case ADRS   : strcpy(typef, "ADRS  ");
                     long_bytes=(imp1-24L)/2;
                     break;

       case OBJ71  : strcpy(typef, "OBJ71 ");
                     long_bytes=(long) imp1/2;
                     break;

       case SYM71  : strcpy(typef, "SYM71 ");
                     long_bytes=(long) imp1/2;
                     break;


       case PR_41  : strcpy(typef, "PR-41 ");
                     long_bytes=imp1;
                     break;

       case CA_41  : strcpy(typef, "CA-41 ");
                     long_bytes=imp1;
                     break;

       case XM_41  : strcpy(typef, "XM-41 ");
                     long_bytes=imp1;
                     break;

       case ML_41  : strcpy(typef, "ML-41 ");
                     long_bytes=imp1;
                     break;

       case BU_41  : strcpy(typef, "BU-41 ");
                     long_bytes=imp1;
                     break;

       case ST_41  : strcpy(typef, "ST-41 ");
                     long_bytes=imp1;
                     break;

       case LEX75  : strcpy(typef, "LEX75 ");
                     long_bytes=long_file*256L;
                     break;

       case TEXT75 : strcpy(typef, "TEXT75");
                     long_bytes=long_file*256L;
                     break;

       case APPT75 : strcpy(typef, "APPT75");
                     long_bytes=long_file*256L;
                     break;

       case IOR75  : strcpy(typef, "IOR75 ");
                     long_bytes=long_file*256L;
                     break;

       case BAS75  : strcpy(typef, "BAS75 ");
                     long_bytes=long_file*256L;
                     break;

       case VISI75 : strcpy(typef, "VISI75");
                     long_bytes=long_file*256L;
                     break;

       case ROM75  : strcpy(typef, "ROM75 ");
                     long_bytes=long_file*256L;
                     break;

       default     : sprintf(typef, "%-6d", type);        /*fich. non reconnu*/
                     long_bytes=long_file*256L;
                     break;
      }

                                                    /* affichage des donnes */
    fprintf(stdout, "File %s : Type=%s   Length = %ld bytes\n",
                                  lif_name, typef, long_bytes);

    country(0, &c_country);
    if(c_country.co_date == 1)
      {
       fprintf(stdout, "Date = %02d/%02d/%02d  Time = %02d:%02d\n",
                      gdh.day, gdh.month, gdh.year, gdh.hour, gdh.min);
      }
    else
      {
       fprintf(stdout, "Date = %02d/%02d/%02d   Time = %02d:%02d\n",
                      gdh.month, gdh.day, gdh.year, gdh.hour, gdh.min);
      }

    if(private || secure)
      {
       fprintf(stdout, "Status = ");
       if(private)                                       /* si fichier priv */
	  fprintf(stdout, "private  ");
       if(secure)                                    /* si fichier privatis */
	  fprintf(stdout, "secured");
       fprintf(stdout, "\n");
      }

    fprintf(stdout, "Directory Entry number = %d (in sector number %d)\n",
						 pos_dir, (pos_dir / 8) + 2);
    fprintf(stdout, "File Position = %d   Length in records = %d\n",
						      first_sect, long_file);
    fin(0);
   }
