/*****************************************************************************/
/*****************************************************************************/
/**                              LIFCAT.C                                   **/
/**                Listage de catalogue de disquette LIF                    **/
/**                                                                         **/
/**    Cration : 06/10/90               Auteur : JB                        **/
/**    Derniere modification : 06/02/91                                     **/
/**       Correction du calcul de la longueur des fichiers OBJ71, SYM71     **/
/**                                                                         **/
/*****************************************************************************/
/*****************************************************************************/
              /* normalisation de country,  inclure avant "#include <dos.h>" 
                            si utilisation de cette structure avec TURBO C++ */
#define COUNTRY country   

#include "getopt.c"
#include "lif.c"

#if defined(__TURBOC__)        /* fonctions dpendant du type de compilateur */
#include "lif.tc"
#else
#include "lif.msc"
#endif

void main(int argc, char *argv[])
   {
    int  device;                           /* numro du lecteur de disquette */
    int  eff;                       /* flag d'affichage des fichiers effacs */
    int  ptext;                       /* flag de prsence de texte optionnel */
    int  stype;                                 /* flag de selection de type */
    char atxt[60], ttype[15];             /* paramtres des options -a et -t */
    int  formc, forml;        /* flags d'affichages de formats court et long */
    LIFDIR dir;                 /* structure contenant l'entre du directory */
    char name[11];                                     /* nom de fichier LIF */
    int  private, secure;                 /* flags de protections du fichier */
    int  ntype;                         /* code numrique du type de fichier */
    int  long_file;                /* longueur du fichier en enregistrements */
    int  file_start;                  /* enregistrement de dpart du fichier */
    GDH  gdh;           /* structure contenant la date et l'heure du fichier */
    long imp1, imp2;               /* variables dpendant du type de fichier */
    char status;                     /* tat du fichier ' ', 'S', 'P' ou 'E' */
    char ligne[100];                                       /* ligne affiche */
    char typef[10], datef[40];          /* type de fichier et date, en Texte */
    unsigned int  longd;         /* longueur en enregistrements du directory */
    unsigned int  nb_files=0;                 /* nombre de fichiers affichs */
    unsigned long long_bytes;               /* lonqueur du fichier en octets */
    unsigned int  ltotale=0;        /* somme longueur des fichiers en enreg. */
    long ltotalo=0L;                /* somme longueur des fichiers en octets */
    int  errflag;                                           /* flag d'erreur */
    struct country c_country;       /* struct contenant le format de la date */
    int i, j;
    char c;

    formc = 0;                   /* initialisation des paramtres par dfaut */
    forml = 0;
    eff = 0;
    stype = 0;
    device = 0;
    ptext=0;
    strcpy(atxt, "");

                                                   /* analyse des parametres */
    errflag=0;
    SW='-';
    while((c=(char) getopt(argc, argv, "a:cd:elt:")) != EOF)
      {
       switch(c)
         {
          case 'a' : strcpy(atxt, optarg);                   /* texte ajout */
                     ptext=1;
                     break;

          case 'c' : formc=1;                                /* format court */
                     break;

          case 'd' : device = *optarg-'0';        /* lecteur de disquette */
                     if((device != 0) && (device != 1))
                        errflag++; 
                     break;

          case 'e' : eff = 1;                            /* fichiers effacs */
                     break;

          case 'l' : forml = 1;                               /* format long */
                     break;

          case 't' : strcpy(ttype, optarg);             /* selection de type */
                     strupr(ttype);                 /* mise en forme du type */
                     for(i=strlen(ttype); i<6; i++)   /* avec espaces en fin */
                        strcat(ttype, " ");
                     stype=1;
                     break;

          case '?' : errflag++;                                 /* si erreur */
                     break;
         }
      }

  
    if(errflag)                                             /* fin si erreur */
      {
       fprintf(stderr,
      "usage : lifcat [-a text] [-c] [-d drive_number] [-e] [-l] [-t type]\n");
       exit(-1);
      }

    init_dsk();                    /* initialisation du lecteur de disquette */

                                      /* lecture de l'entte de la disquette */
    errflag=read_dsk(device, 0, buff_sect);
    if(errflag)                                             /* fin si erreur */
      {
       fprintf(stderr, "error : not a LIF disk");
       fin(-1);
      }

    if(forml)                                  /* si format long selectionn */
      {
       fprintf(stdout, "  DISK : %s\n", buff_sect+2);     /* affichage label */

       if(formc != 1)                              /* si pas de format court */
         {                            /* affichage d'un en tte de catalogue */
          fprintf(stdout, "NAME        S TYPE     SIZE ");
          fprintf(stdout, " DATE           ");
          if(ptext)                                  /* si presence de texte */
             fprintf(stdout, " TEXT");
          fprintf(stdout, "\n");
          fprintf(stdout, "===========================");
          fprintf(stdout, "================");
          if(ptext)
            {
             j=strlen(atxt);
             strcpy(name, "=");
             for(i=1; i<=j+1; i++)
                strcat(name, "=");
             fprintf(stdout, "%s", name);
            }
          fprintf(stdout, "\n");
         }
      }
                              /* longueur en enregistrements de la disquette */
    longd = ((int) buff_sect[18]*256)+(int) buff_sect[19];

    curr_sect=1;                /* initialisation avant lecture du directory */
    curr_dir=7;
    while(read_dir(device, &dir))          /* boucle de lecture du directory */
      {
                                                /* decomposition de l'entre */
       break_dir(name, &private, &secure, &ntype, &file_start, &long_file,
					      &gdh, &imp1, &imp2, &dir);
       if((ntype != 0) || (eff==1))    /* si fichier non effac ou option -e */
         {
          switch(ntype)                                 /* selection du type */
            {
             case 0      : strcpy(typef, "dddddd");        /* fichier effac */
                           long_bytes=long_file*256L; /* calcul longueur aff.*/
                           break;

             case TEXT   : strcpy(typef, "TEXT  ");
                           long_bytes=long_file*256L;
                           break;

             case SDATA  : strcpy(typef, "SDATA ");
                           long_bytes=imp1;
                           break;

             case DATA   : strcpy(typef, "DATA  ");
                           long_bytes=imp1*imp2;
                           break;

             case FORTH  : strcpy(typef, "FORTH ");
                           long_bytes=(long) imp1/2;
                           break;

             case BIN    : strcpy(typef, "BIN   ");
                           long_bytes=(imp1-11L)/2;
                           break;

             case LEX    : strcpy(typef, "LEX   ");
                           long_bytes=(imp1+1L)/2;
                           break;

             case KEY    : strcpy(typef, "KEY   ");
                           long_bytes=(imp1+1L)/2;
                           break;

	     case BASIC  : strcpy(typef, "BASIC ");
                           long_bytes=(imp1-11L)/2;
                           break;

             case ROM71  : strcpy(typef, "ROM71 ");
                           long_bytes=(long) imp1/2;
                           break;

             case APPT   : strcpy(typef, "APPT  ");
                           long_bytes=(long) imp1/2;
                           break;

             case GRAPH  : strcpy(typef, "GRAPH ");
                           long_bytes=(imp1-10L)/2;
                           break;

             case ADRS   : strcpy(typef, "ADRS  ");
                           long_bytes=(imp1-24L)/2;
                           break;

             case OBJ71  : strcpy(typef, "OBJ71 ");
                           long_bytes=(long) imp1/2;
                           break;
             
             case SYM71  : strcpy(typef, "SYM71 ");
                           long_bytes=(long) imp1/2;
                           break;


             case PR_41  : strcpy(typef, "PR-41 ");
                           long_bytes=imp1;
                           break;

             case CA_41  : strcpy(typef, "CA-41 ");
                           long_bytes=imp1;
                           break;

             case XM_41  : strcpy(typef, "XM-41 ");
                           long_bytes=imp1;
                           break;

             case ML_41  : strcpy(typef, "ML-41 ");
                           long_bytes=imp1;
                           break;

             case BU_41  : strcpy(typef, "BU-41 ");
                           long_bytes=imp1;
                           break;

             case ST_41  : strcpy(typef, "ST-41 ");
                           long_bytes=imp1;
                           break;

             case LEX75  : strcpy(typef, "LEX75 ");
                           long_bytes=long_file*256L;
                           break;

             case TEXT75 : strcpy(typef, "TEXT75");
                           long_bytes=long_file*256L;
                           break;

             case APPT75 : strcpy(typef, "APPT75");
                           long_bytes=long_file*256L;
                           break;

             case IOR75  : strcpy(typef, "IOR75 ");
                           long_bytes=long_file*256L;
                           break;

             case BAS75  : strcpy(typef, "BAS75 ");
                           long_bytes=long_file*256L;
                           break;

             case VISI75 : strcpy(typef, "VISI75");
                           long_bytes=long_file*256L;
                           break;

             case ROM75  : strcpy(typef, "ROM75 ");
                           long_bytes=long_file*256L;
                           break;

             default     : sprintf(typef, "%-6d", ntype); /*fich. non reconnu*/
                           long_bytes=long_file*256L;
                           break;
            }

          if(ntype)                                 /* si fichier non effac */
            ltotale += long_file;       /* ajout du nombre d'enreg. utiliss */

                                  /* formatage date (suivant format systme) */
          country(0, &c_country);
          if(c_country.co_date == 1)
            {
             sprintf(datef, " %02d/%02d/%02d %02d:%02d", gdh.day,
                                                         gdh.month,
                                                         gdh.year,
                                                         gdh.hour,
                                                         gdh.min);
            }
          else
            {
             sprintf(datef, " %02d/%02d/%02d %02d:%02d", gdh.month,
                                                         gdh.day,
                                                         gdh.year,
                                                         gdh.hour,
                                                         gdh.min);
            }


          status=' ';                           /* formatage tat du fichier */
          if(private)
            status='P';
          if(secure)
            status='S';
          if(private && secure)
            status='E';

          j=strcmp(ttype, typef);
          if((stype==0) || (j==0))         /* si type de fichier selectionn */
            {
             nb_files++;
             ltotalo += long_bytes;         /* somme des longueurs en octets */
             if(formc)                                    /* si format court */
               {
                fprintf(stdout, "%10s ", name);          /* affichage du nom */
                if(!(nb_files % 7))   /* ligne suivante toutes les 7 entres */
                   fprintf(stdout, "\n");
               }
             else                                                   /* sinon */
               {                              /* affichage nom+type+longueur */
                sprintf(ligne, "%s  %c %s %6ld ", 
                                         name, status, typef, long_bytes);
                if(forml)                                  /* si format long */
                   strcat(ligne, datef);
                strcat(ligne, "  ");      /* affichage texte, le cas echant */
                strcat(ligne, atxt);
                fprintf(stdout, "%s\n", ligne);
               }
            }
         }
      }

    if(formc && (nb_files % 7))   /* si format court et 7 fichiers sur ligne */
       fprintf(stdout, "\n");

    if(forml)                      /*  si format long, affichage nb fichiers */
      {
       fprintf(stdout, "   %d files / %ld bytes \n", nb_files, ltotalo);
       fprintf(stdout, "   %ld bytes free\n", (2462L-(longd+ltotale))*256);
      }

    fin(0);                /* rinitialisation du lecteur et fin du programe */
   }
